#include <qgames.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include "alloc.h"

void main()
{
	int MovX,MovY;
	STMOUSEMAP stMap;
	RGBPAL rgbPal[256];
	PSTR ScrBuff;
	BITMAP bmp1,bmp2,bmp3,bmp4;
	BMPOUTINFO BOut,BOut1;

	if(!GetMouseInit())
	{
		printf(":  \n");
		return;
	}
	if(LoadBMPPal("1.bmp",rgbPal) != QG_OK)
	{
		printf(": ⥭ 䠩 1.bmp\n");
		return;
	}
	if(LoadBMPInfo("1.bmp",&bmp1) != QG_OK)
	{
		printf(": ⥭ 䠩 1.bmp\n");
		return;
	}
	bmp2.Width = bmp3.Width = bmp1.Width;
	bmp2.Height = bmp3.Height = bmp1.Height;

	if(LoadBMPInfo("4.bmp",&bmp4) != QG_OK)
	{
		printf(": ⥭ 䠩 4.bmp\n");
		return;
	}

	bmp1.Buffer = malloc(bmp1.Width * bmp1.Height);

	if(bmp1.Buffer == NULL)
	{
		printf(": 墠⠥ \n");
		return;
	}
	bmp2.Buffer = malloc(bmp1.Width * bmp1.Height);
	if(bmp2.Buffer == NULL)
	{
		free(bmp1.Buffer);
		printf(": 墠⠥ \n");
		return;
	}

	bmp3.Buffer = malloc(bmp1.Width * bmp1.Height);
	if(bmp3.Buffer == NULL)
	{
		free(bmp1.Buffer);
		free(bmp2.Buffer);
		printf(": 墠⠥ \n");
		return;
	}

	bmp4.Buffer = malloc(bmp4.Width * bmp4.Height);

	if(bmp4.Buffer == NULL)
	{
		free(bmp1.Buffer);
		free(bmp2.Buffer);
		free(bmp3.Buffer);
		printf(": 墠⠥ \n");
		return;
	}

	if(LoadBMPData("1.bmp",&bmp1) != QG_OK)
	{
		free(bmp1.Buffer);
		free(bmp2.Buffer);
		free(bmp3.Buffer);
		free(bmp4.Buffer);
		printf(": ⥭ 䠩 1.bmp\n");
		return;
	}
	if(LoadBMPData("2.bmp",&bmp2) != QG_OK)
	{
		printf(": ⥭ 䠩 2.bmp\n");
          free(bmp1.Buffer);
		free(bmp2.Buffer);
		free(bmp3.Buffer);
		free(bmp4.Buffer);
		return;
	}

	if(LoadBMPData("3.bmp",&bmp3) != QG_OK)
	{
		printf(": ⥭ 䠩 3.bmp\n");
		free(bmp1.Buffer);
		free(bmp2.Buffer);
		free(bmp3.Buffer);
		free(bmp4.Buffer);
		return;
	}

	if(LoadBMPData("4.bmp",&bmp4) != QG_OK)
	{
		printf(": ⥭ 䠩 4.bmp\n");
		free(bmp1.Buffer);
		free(bmp2.Buffer);
		free(bmp3.Buffer);
		free(bmp4.Buffer);
		return;
	}

	ScrBuff = malloc(64000);
	if(ScrBuff == NULL)
	{
		free(bmp1.Buffer);
		free(bmp2.Buffer);
		free(bmp3.Buffer);
		free(bmp4.Buffer);
		printf(": 墠⠥ \n");
		return;
	}

	SetDisplayMode(VGA_MODE);
	SetVirScreen(ScrBuff);
	BOut1.PosX = BOut.PosX = 0;
	BOut1.PosY = BOut.PosY = 0;
	SetDisplayPal(rgbPal);
	while(1)
	{
		if(kbhit())
			break;
		GetMouseMoving(&MovX,&MovY);
		GetMouseMap(&stMap);

		if(MovX > 0)
			BOut.PosX++;
		else if(MovX < 0)
			BOut.PosX--;
		if(MovY > 0)
			BOut.PosY++;
		else if(MovY < 0)
			BOut.PosY--;

		VgaBitmap(&bmp4,&BOut1);

		if(stMap.RightKey)
			VgaC_BitmapBounds(&bmp2,&BOut);
		else if(stMap.LeftKey)
			VgaC_BitmapBounds(&bmp3,&BOut);
		else
			VgaC_BitmapBounds(&bmp1,&BOut);
		CopyVirToScr_WDV();
	}
	if(!getch())
		getch();
	SetDisplayMode(TEXT_MODE);
	free(bmp1.Buffer);
	free(bmp2.Buffer);
	free(bmp3.Buffer);
	free(ScrBuff);
}