/*
樠  ࠡ  ஬ VGA...
*/
#include "qgvga.h"


void SetDisplayMode(BYTE Mode)
{
	libDisplayMode = Mode;
	switch(Mode)
	{
	case TEXT_MODE:
		asm mov ax,3;
		asm int 0x10;
		return;
	case VGA_MODE:
		asm mov ax,0x13
		asm int 0x10;
		return;
	default:
		return;
	}
}

void SetDisplayPal(PRGBPAL pRgbPal)
{
	WORD Amount;

	switch(libDisplayMode)
	{
	case TEXT_MODE:
		Amount = 48;
		break;
	case VGA_MODE:
		Amount = 768;
		break;
	default:
		return;
	}

	WaitDisplayVrt();

	BOUT(0x3C8,0);

	asm mov cx,Amount;
	asm mov dx,0x3C9;
	asm les di,pRgbPal;
NEXTPAL:
	asm mov al,[es:di];
	asm shr al,2;
	asm out dx,al;
	asm inc di;
	asm loop NEXTPAL;
}

void WaitDisplayVrt(void)
{
	register BYTE Value;
	do
	{
		BIN(0x3DA,Value);
	}while(!(Value & 8));
}

BOOL GetDisplayVrt(void)
{
	register BYTE Value;
	BIN(0x3DA,Value);
	return Value & 8;
}

void CopyVirToScr_WDV(void)
{
	register BYTE Value;
	do
	{
		BIN(0x3DA,Value);
	}while(!(Value & 8));

	asm push ds;
	asm lds si,libVirScreen;
	asm mov di,0xA000;
	asm mov es,di;
	asm xor di,di;
	asm mov cx,32000;
	asm cld;
	asm rep movsw;
	asm pop ds;
}

void CopyVirToScr(void)
{
	register BYTE Value;
	do
	{
		BIN(0x3DA,Value);
	}while(!(Value & 8));

	asm push ds;
	asm lds si,libVirScreen;
	asm mov di,0xA000;
	asm mov es,di;
	asm xor di,di;
	asm mov cx,32000;
	asm cld;
	asm rep movsw;
	asm pop ds;
}

void ClearScreen(BYTE bColor)
{
	asm mov al,bColor;
	asm les di,libVirScreen;
	asm mov ah,al;
	asm mov cx,32000;
	asm cld;
	asm rep stosw;
}



void SetVirScreen(PSTR pBuffer)
{
	libVirScreen = pBuffer;
}
